extern double TakeProfit =   15; 
extern double StopLoss   =    0; 
extern double Filter_In  =    1;
extern double Filter_Out =    1;
extern int    Day_Open   =    8;
extern int    Start_Trade =   8;
extern int    Stop_Trade  =  20;

int NumOrder_Long ;
int NumOrder_Short ;  


//+------------------------------------------------------------------+ 
//|                                                                  | 
//+------------------------------------------------------------------+ 


int start() 
  { 
  bool Inside_Long_1, Inside_Long_2, Inside_Long_3, Inside_Long_4 ;
  bool Inside_Short_1, Inside_Short_2, Inside_Short_3, Inside_Short_4;
  bool Long_1, Long_2, Long_3, Long_4  ;
  bool Short_1, Short_2, Short_3, Short_4 ;

  int cnt, ticket, total, spread; 
  double Lots;
    
if (Symbol()== "EURUSD") {Lots = 0.04 && spread==MarketInfo("EURUSD",MODE_SPREAD);}
if (Symbol()== "GBPUSD") {Lots = 0.02 && spread==MarketInfo("GBPUSD",MODE_SPREAD);}
if (Symbol()== "AUDUSD") {Lots = 0.06 && spread==MarketInfo("AUDUSD",MODE_SPREAD);}
if (Symbol()== "EURGBP") {Lots = 0.03 && spread==MarketInfo("EURGBP",MODE_SPREAD);}
if (Symbol()== "EURJPY") {Lots = 0.03 && spread==MarketInfo("EURJPY",MODE_SPREAD);}
if (Symbol()== "USDCHF") {Lots = 0.03 && spread==MarketInfo("USDCHF",MODE_SPREAD);}
if (Symbol()== "USDJPY") {Lots = 0.04 && spread==MarketInfo("USDJPY",MODE_SPREAD);}
if (Symbol()== "EURCHF") {Lots = 0.03 && spread==MarketInfo("EURCHF",MODE_SPREAD);}
if (Symbol()== "USDCAD") {Lots = 0.05 && spread==MarketInfo("USDCAD",MODE_SPREAD);}


   if(Bars<100) 
     { 
      Print("bars less than 100"); 
      return(0);  
     } 

     if(isNewBar()) {NumOrder_Long  = 0 ;} 
     if(isNewBar()) {NumOrder_Short = 0 ;} 
     
     if(TakeProfit < 5) 
     { 
      Print("TakeProfit less than 5"); 
      return(0);  // check TakeProfit 
     } 

   total=OrdersTotal();

// to simplify the coding and speed up access 
// data are put into internal variables 


   Inside_Long_1   =  High[1] <= High[2] && Low[1] >= Low[2] && High[1] >= iCustom(NULL,0,"daily_open_line",Day_Open,0,0); 
   Inside_Long_2   =  High[2] <= High[3] && Low[2] >= Low[3] && High[2] >= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && High[1] <= (High[2] + Filter_In*Point) ; 
   Inside_Long_3   =  High[3] <= High[4] && Low[3] >= Low[4] && High[3] >= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && High[2] <= (High[3] + Filter_In*Point) && High[1] <= (High[3] + Filter_In*Point) ;  
   Inside_Long_4   =  High[4] <= High[5] && Low[4] >= Low[5] && High[4] >= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && High[3] <= (High[4] + Filter_In*Point) && High[2] <= (High[4] + Filter_In*Point) && High[1] <= (High[4] + Filter_In*Point) ;  

   Inside_Short_1  =  High[1] <= High[2] && Low[1] >= Low[2] && Low[1] <= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) ; 
   Inside_Short_2  =  High[2] <= High[3] && Low[2] >= Low[3] && Low[2] <= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Low[1] >= (Low[2] - Filter_In*Point) ; 
   Inside_Short_3  =  High[3] <= High[4] && Low[3] >= Low[4] && Low[3] <= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Low[2] >= (Low[3] - Filter_In*Point) && Low[1] >= (Low[3] - Filter_In*Point) ; 
   Inside_Short_4  =  High[4] <= High[5] && Low[4] >= Low[5] && Low[4] <= iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Low[3] >= (Low[4] - Filter_In*Point) && Low[2] >= (Low[4] - Filter_In*Point) && Low[1] >= (Low[4] - Filter_In*Point) ; 

   Long_1 = Bid > (High[1] + Filter_In*Point) && Inside_Long_1 && Bid > iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade  ; 
   Long_2 = Bid > (High[2] + Filter_In*Point) && Inside_Long_2 && Bid > iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade  ; 
   Long_3 = Bid > (High[3] + Filter_In*Point) && Inside_Long_3 && Bid > iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade  ; 
   Long_4 = Bid > (High[4] + Filter_In*Point) && Inside_Long_4 && Bid > iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade  ; 

   Short_1  = Bid < (Low[1] - Filter_In*Point) && Inside_Short_1 && Bid < iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade ;  
   Short_2  = Bid < (Low[2] - Filter_In*Point) && Inside_Short_2 && Bid < iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade ;  
   Short_3  = Bid < (Low[3] - Filter_In*Point) && Inside_Short_3 && Bid < iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade ;  
   Short_4  = Bid < (Low[4] - Filter_In*Point) && Inside_Short_4 && Bid < iCustom(NULL,0,"daily_open_line",Day_Open,0,0) && Hour() >= Start_Trade && Hour() <= Stop_Trade ;  


// no opened orders identified 

      if(AccountFreeMargin()<(5000*Lots)) 
        { 
         Print("We have no money. Free Margin = ", AccountFreeMargin()); 
         return(0);  
        } 
     
// check for long position (BUY) possibility 

      if(Long_1) 
      {
         if(NumOrder_Long == 0)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,NULL,Low[1]-Filter_Out*Point,Bid+TakeProfit*Point,"Up",20080606,0,Green); 
         if(ticket>0) 
           { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
             { 
             Print("BUY order opened : ",OrderOpenPrice()); 
             NumOrder_Long = 1; 
             } 
           } 
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
      }

      if(Long_2) 
      {
         if(NumOrder_Long == 0)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,NULL,Low[2]-Filter_Out*Point,Bid+TakeProfit*Point,"Up",20080606,0,Green); 
         if(ticket>0) 
           { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
             { 
             Print("BUY order opened : ",OrderOpenPrice()); 
             NumOrder_Long = 1; 
             } 
           } 
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0);
         } 
      }  

      if(Long_3) 
      {
        if(NumOrder_Long == 0)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,NULL,Low[3]-Filter_Out*Point,Bid+TakeProfit*Point,"Up",20080606,0,Green); 
         if(ticket>0) 
           { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
              {   
              Print("BUY order opened : ",OrderOpenPrice()); 
              NumOrder_Long = 1; 
              } 
           } 
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
      }  

      if(Long_4) 
      {
         if(NumOrder_Long == 0)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,NULL,Low[4]-Filter_Out*Point,Bid+TakeProfit*Point,"Up",20080606,0,Green); 
         if(ticket>0) 
            { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               { 
               Print("BUY order opened : ",OrderOpenPrice()); 
               NumOrder_Long = 1; 
               } 
            } 
        else Print("Error opening BUY order : ",GetLastError()); 
        return(0); 
        }
      }  


// check for short position (SELL) possibility 

      if(Short_1)
      {   
         if(NumOrder_Short == 0)
         {        
          ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,NULL,High[1]+Filter_Out*Point+spread,Ask-TakeProfit*Point,"Down",20080606,0,Red); 
          if(ticket>0) 
           { 
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
             { 
             Print("SELL order opened : ",OrderOpenPrice()); 
             NumOrder_Short = 1;
             } 
           } 
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
         } 
      } 

      if(Short_2)
      {    
          if(NumOrder_Short == 0)
          {        
          ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,NULL,High[2]+Filter_Out*Point+spread,Ask-TakeProfit*Point,"Down",20080606,0,Red); 
          if(ticket>0) 
           { 
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
              { 
              Print("SELL order opened : ",OrderOpenPrice()); 
              NumOrder_Short = 1;
              } 
           } 
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0);
          }  
      }      
   

      if(Short_3)
        {          
          if(NumOrder_Short == 0)
          {   
             ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,NULL,High[3]+Filter_Out*Point+spread,Ask-TakeProfit*Point,"Down",20080606,0,Red); 
             if(ticket>0) 
             { 
             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               { 
               Print("SELL order opened : ",OrderOpenPrice()); 
               NumOrder_Short = 1;
               } 
             } 
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
          } 
        }        

      if(Short_4)
        {    
          if(NumOrder_Short == 0)
          {          
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,NULL,High[4]+Filter_Out*Point+spread,Ask-TakeProfit*Point,"Down",20080606,0,Red); 
            if(ticket>0) 
            { 
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
              { 
              Print("SELL order opened : ",OrderOpenPrice()); 
              NumOrder_Short = 1;
              } 
            } 
          } 
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }          

} 

// the end. 

bool isNewBar() 

{ 
   static datetime lastbar=0; 
   datetime curbar = Time[0]; 
   if(lastbar!=curbar) 
   { 
   lastbar=curbar; 
   return (true); 
   } 

   else 
   { 
      return(false); 
   } 

}

